
#include <LiquidCrystal.h>
#include "CAN.h"
#include "LIN.h"


// select the pins used on the LCD panel
LiquidCrystal lcd(8, 9, 4, 5, 6, 7);

// define some values used by the panel and buttons
int lcd_key     = 0;
int adc_key_in  = 0;
#define btnRIGHT  0
#define btnUP     1
#define btnDOWN   2
#define btnLEFT   3
#define btnSELECT 4
#define btnNONE   5

// read the buttons
int read_LCD_buttons()
{
 adc_key_in = analogRead(0);      // read the value from the sensor 
 if (adc_key_in > 1000) return btnNONE; // We make this the 1st option for speed reasons since it will be the most likely result
 // For V1.1 us this threshold
 if (adc_key_in < 50)   return btnRIGHT;  
 if (adc_key_in < 250)  return btnUP; 
 if (adc_key_in < 450)  return btnDOWN; 
 if (adc_key_in < 650)  return btnLEFT; 
 if (adc_key_in < 800)  return btnSELECT;  
 return btnNONE;  // when all others fail, return this...
}
int led = 13;

void setup()
{
 pinMode(led, OUTPUT);  
 CAN.begin();
 CAN.baudConfig(125);
 CAN.set11(0,0x00AB,0x000000);
  
 LIN_init(832);
 LIN_TXenable();
  
 lcd.begin(16, 2);              // start the library
 lcd.setCursor(0,0);
 lcd.print("CAN test"); // print a simple message
}
 
void loop()
{
  char buff[8]={1,2,3,4,5,6,7,8};
  char msglen=0;
  unsigned long id=0;
  digitalWrite(led, HIGH);   // turn the LED on (HIGH is the voltage level)
  delay(100);               // wait for a second
  digitalWrite(led, LOW);    // turn the LED off by making the voltage LOW
  delay(1000);               // wait for a second
  CAN.send29(buff,8,0x007918);
  CAN.read(0,buff,&msglen,&id);
  if (msglen>=0){
    lcd.setCursor(0,1);
    lcd.print((long int)id);
  }
  LIN_send(0xAA);
  lcd.setCursor(12,0);            // move cursor to second line "1" and 9 spaces over
  lcd.print(millis()/1000);      // display seconds elapsed since power-up
}


/*
 lcd.setCursor(9,1);            // move cursor to second line "1" and 9 spaces over
 lcd.print(millis()/1000);      // display seconds elapsed since power-up
 lcd.setCursor(0,1);            // move to the begining of the second line

lcd_key = read_LCD_buttons();  // read the buttons

 switch (lcd_key)               // depending on which button was pushed, we perform an action
 {
   case btnRIGHT:
     break;
   case btnLEFT:
     break;
   case btnUP:
     break;
   case btnDOWN:
     break;
   case btnSELECT:
     break;
   case btnNONE:
 }
*/
